### Hierarchy

- Uint8Array
  - Buffer

## Index

### Properties

- BYTES_PER_ELEMENT
- [toStringTag]
- buffer
- byteLength
- byteOffset
- length

### Methods

- [iterator]
- at
- compare
- copy
- copyWithin
- entries
- equals
- every
- fill
- filter
- find
- findIndex
- forEach
- includes
- indexOf
- join
- keys
- lastIndexOf
- map
- readBigInt64BE
- readBigInt64LE
- readBigUInt64BE
- readBigUInt64LE
- readBigUint64BE
- readBigUint64LE
- readDoubleBE
- readDoubleLE
- readFloatBE
- readFloatLE
- readInt16BE
- readInt16LE
- readInt32BE
- readInt32LE
- readInt8
- readIntBE
- readIntLE
- readUInt16BE
- readUInt16LE
- readUInt32BE
- readUInt32LE
- readUInt8
- readUIntBE
- readUIntLE
- readUint16BE
- readUint16LE
- readUint32BE
- readUint32LE
- readUint8
- readUintBE
- readUintLE
- reduce
- reduceRight
- reverse
- set
- slice
- some
- sort
- subarray
- swap16
- swap32
- swap64
- toJSON
- toLocaleString
- toString
- valueOf
- values
- write
- writeBigInt64BE
- writeBigInt64LE
- writeBigUInt64BE
- writeBigUInt64LE
- writeBigUint64BE
- writeBigUint64LE
- writeDoubleBE
- writeDoubleLE
- writeFloatBE
- writeFloatLE
- writeInt16BE
- writeInt16LE
- writeInt32BE
- writeInt32LE
- writeInt8
- writeIntBE
- writeIntLE
- writeUInt16BE
- writeUInt16LE
- writeUInt32BE
- writeUInt32LE
- writeUInt8
- writeUIntBE
- writeUIntLE
- writeUint16BE
- writeUint16LE
- writeUint32BE
- writeUint32LE
- writeUint8
- writeUintBE
- writeUintLE

## Properties

### Readonly BYTES_PER_ELEMENT

BYTES_PER_ELEMENT: number

Inherited from Uint8Array.BYTES_PER_ELEMENT

The size in bytes of each element in the array.

### Readonly [toStringTag]

[toStringTag]: "Uint8Array"

Inherited from Uint8Array.__@toStringTag@91

### Readonly buffer

buffer: ArrayBufferLike

Inherited from Uint8Array.buffer

The ArrayBuffer instance referenced by the array.

### Readonly byteLength

byteLength: number

Inherited from Uint8Array.byteLength

The length in bytes of the array.

### Readonly byteOffset

byteOffset: number

Inherited from Uint8Array.byteOffset

The offset in bytes of the array.

### Readonly length

length: number

Inherited from Uint8Array.length

The length of the array.

## Methods

### [iterator]

- [iterator](): IterableIterator<number>

- Inherited from Uint8Array.__@iterator@127

  #### Returns IterableIterator<number>

### at

- at(index: number): number

- Inherited from Uint8Array.at

  Takes an integer value and returns the item at that index, allowing for positive and negative integers. Negative integers count back from the last item in the array.

  #### Parameters

  - ##### index: number

  #### Returns number

### compare

- compare(target: Uint8Array, targetStart?: number, targetEnd?: number, sourceStart?: number, sourceEnd?: number): number

- Compares `buf` with `target` and returns a number indicating whether `buf`comes before, after, or is the same as `target` in sort order. Comparison is based on the actual sequence of bytes in each `Buffer`.

  - `0` is returned if `target` is the same as `buf`
  - `1` is returned if `target` should come before `buf` when sorted.
  - `-1` is returned if `target` should come after `buf` when sorted.

      import { Buffer } from 'buffer';

      const buf1 = Buffer.from('ABC');
      const buf2 = Buffer.from('BCD');
      const buf3 = Buffer.from('ABCD');

      console.log(buf1.compare(buf1));
      // Prints: 0
      console.log(buf1.compare(buf2));
      // Prints: -1
      console.log(buf1.compare(buf3));
      // Prints: -1
      console.log(buf2.compare(buf1));
      // Prints: 1
      console.log(buf2.compare(buf3));
      // Prints: 1
      console.log([buf1, buf2, buf3].sort(Buffer.compare));
      // Prints: [ <Buffer 41 42 43>, <Buffer 41 42 43 44>, <Buffer 42 43 44> ]
      // (This result is equal to: [buf1, buf3, buf2].)

  The optional `targetStart`, `targetEnd`, `sourceStart`, and `sourceEnd`arguments can be used to limit the comparison to specific ranges within `target`and `buf` respectively.

      import { Buffer } from 'buffer';

      const buf1 = Buffer.from([1, 2, 3, 4, 5, 6, 7, 8, 9]);
      const buf2 = Buffer.from([5, 6, 7, 8, 9, 1, 2, 3, 4]);

      console.log(buf1.compare(buf2, 5, 9, 0, 4));
      // Prints: 0
      console.log(buf1.compare(buf2, 0, 6, 4));
      // Prints: -1
      console.log(buf1.compare(buf2, 5, 6, 5));
      // Prints: 1

  `ERR_OUT_OF_RANGE` is thrown if `targetStart < 0`, `sourceStart < 0`,`targetEnd > target.byteLength`, or `sourceEnd > source.byteLength`.

  since

    v0.11.13

  #### Parameters

  - ##### target: Uint8Array

    A `Buffer` or {@link Uint8Array} with which to compare `buf`.

  - ##### Optional targetStart: number

  - ##### Optional targetEnd: number

  - ##### Optional sourceStart: number

  - ##### Optional sourceEnd: number

  #### Returns number

### copy

- copy(target: Uint8Array, targetStart?: number, sourceStart?: number, sourceEnd?: number): number

- Copies data from a region of `buf` to a region in `target`, even if the `target`memory region overlaps with `buf`.

  `TypedArray.prototype.set()` performs the same operation, and is available for all TypedArrays, including Node.js `Buffer`s, although it takes different function arguments.

      import { Buffer } from 'buffer';

      // Create two `Buffer` instances.
      const buf1 = Buffer.allocUnsafe(26);
      const buf2 = Buffer.allocUnsafe(26).fill('!');

      for (let i = 0; i < 26; i++) {
        // 97 is the decimal ASCII value for 'a'.
        buf1[i] = i + 97;
      }

      // Copy `buf1` bytes 16 through 19 into `buf2` starting at byte 8 of `buf2`.
      buf1.copy(buf2, 8, 16, 20);
      // This is equivalent to:
      // buf2.set(buf1.subarray(16, 20), 8);

      console.log(buf2.toString('ascii', 0, 25));
      // Prints: !!!!!!!!qrst!!!!!!!!!!!!!

      import { Buffer } from 'buffer';

      // Create a `Buffer` and copy data from one region to an overlapping region
      // within the same `Buffer`.

      const buf = Buffer.allocUnsafe(26);

      for (let i = 0; i < 26; i++) {
        // 97 is the decimal ASCII value for 'a'.
        buf[i] = i + 97;
      }

      buf.copy(buf, 0, 4, 10);

      console.log(buf.toString());
      // Prints: efghijghijklmnopqrstuvwxyz

  since

    v0.1.90

  #### Parameters

  - ##### target: Uint8Array

    A `Buffer` or {@link Uint8Array} to copy into.

  - ##### Optional targetStart: number

  - ##### Optional sourceStart: number

  - ##### Optional sourceEnd: number

  #### Returns number

  The number of bytes copied.

### copyWithin

- copyWithin(target: number, start: number, end?: number): <internal>.Buffer

- Inherited from Uint8Array.copyWithin

  Returns the this object after copying a section of the array identified by start and end to the same array starting at position target

  #### Parameters

  - ##### target: number

    If target is negative, it is treated as length+target where length is the length of the array.

  - ##### start: number

    If start is negative, it is treated as length+start. If end is negative, it is treated as length+end.

  - ##### Optional end: number

    If not specified, length of the this object is used as its default value.

  #### Returns <internal>.Buffer

### entries

- entries(): IterableIterator<[number, number]>

- Overrides Uint8Array.entries

  Creates and returns an iterator of `[index, byte]` pairs from the contents of `buf`.

      import { Buffer } from 'buffer';

      // Log the entire contents of a `Buffer`.

      const buf = Buffer.from('buffer');

      for (const pair of buf.entries()) {
        console.log(pair);
      }
      // Prints:
      //   [0, 98]
      //   [1, 117]
      //   [2, 102]
      //   [3, 102]
      //   [4, 101]
      //   [5, 114]

  since

    v1.1.0

  #### Returns IterableIterator<[number, number]>

### equals

- equals(otherBuffer: Uint8Array): boolean

- Returns `true` if both `buf` and `otherBuffer` have exactly the same bytes,`false` otherwise. Equivalent to `buf.compare(otherBuffer) === 0`.

      import { Buffer } from 'buffer';

      const buf1 = Buffer.from('ABC');
      const buf2 = Buffer.from('414243', 'hex');
      const buf3 = Buffer.from('ABCD');

      console.log(buf1.equals(buf2));
      // Prints: true
      console.log(buf1.equals(buf3));
      // Prints: false

  since

    v0.11.13

  #### Parameters

  - ##### otherBuffer: Uint8Array

    A `Buffer` or {@link Uint8Array} with which to compare `buf`.

  #### Returns boolean

### every

- every(predicate: (value: number, index: number, array: Uint8Array) => unknown, thisArg?: any): boolean

- Inherited from Uint8Array.every

  Determines whether all the members of an array satisfy the specified test.

  #### Parameters

  - ##### predicate: (value: number, index: number, array: Uint8Array) => unknown

    A function that accepts up to three arguments. The every method calls the predicate function for each element in the array until the predicate returns a value which is coercible to the Boolean value false, or until the end of the array.

    - - (value: number, index: number, array: Uint8Array): unknown

      - #### Parameters

        - ##### value: number

        - ##### index: number

        - ##### array: Uint8Array

        #### Returns unknown

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the predicate function. If thisArg is omitted, undefined is used as the this value.

  #### Returns boolean

### fill

- fill(value: string | number | Uint8Array, offset?: number, end?: number, encoding?: BufferEncoding): <internal>.Buffer

- Overrides Uint8Array.fill

  Fills `buf` with the specified `value`. If the `offset` and `end` are not given, the entire `buf` will be filled:

      import { Buffer } from 'buffer';

      // Fill a `Buffer` with the ASCII character 'h'.

      const b = Buffer.allocUnsafe(50).fill('h');

      console.log(b.toString());
      // Prints: hhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhh

  `value` is coerced to a `uint32` value if it is not a string, `Buffer`, or integer. If the resulting integer is greater than `255` (decimal), `buf` will be filled with `value &#x26; 255`.

  If the final write of a `fill()` operation falls on a multi-byte character, then only the bytes of that character that fit into `buf` are written:

      import { Buffer } from 'buffer';

      // Fill a `Buffer` with character that takes up two bytes in UTF-8.

      console.log(Buffer.allocUnsafe(5).fill('\u0222'));
      // Prints: <Buffer c8 a2 c8 a2 c8>

  If `value` contains invalid characters, it is truncated; if no valid fill data remains, an exception is thrown:

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(5);

      console.log(buf.fill('a'));
      // Prints: <Buffer 61 61 61 61 61>
      console.log(buf.fill('aazz', 'hex'));
      // Prints: <Buffer aa aa aa aa aa>
      console.log(buf.fill('zz', 'hex'));
      // Throws an exception.

  since

    v0.5.0

  #### Parameters

  - ##### value: string | number | Uint8Array

    The value with which to fill `buf`.

  - ##### Optional offset: number

  - ##### Optional end: number

  - ##### Optional encoding: BufferEncoding

  #### Returns <internal>.Buffer

  A reference to `buf`.

### filter

- filter(predicate: (value: number, index: number, array: Uint8Array) => any, thisArg?: any): Uint8Array

- Inherited from Uint8Array.filter

  Returns the elements of an array that meet the condition specified in a callback function.

  #### Parameters

  - ##### predicate: (value: number, index: number, array: Uint8Array) => any

    A function that accepts up to three arguments. The filter method calls the predicate function one time for each element in the array.

    - - (value: number, index: number, array: Uint8Array): any

      - #### Parameters

        - ##### value: number

        - ##### index: number

        - ##### array: Uint8Array

        #### Returns any

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the predicate function. If thisArg is omitted, undefined is used as the this value.

  #### Returns Uint8Array

### find

- find(predicate: (value: number, index: number, obj: Uint8Array) => boolean, thisArg?: any): number

- Inherited from Uint8Array.find

  Returns the value of the first element in the array where predicate is true, and undefined otherwise.

  #### Parameters

  - ##### predicate: (value: number, index: number, obj: Uint8Array) => boolean

    find calls predicate once for each element of the array, in ascending order, until it finds one where predicate returns true. If such an element is found, find immediately returns that element value. Otherwise, find returns undefined.

    - - (value: number, index: number, obj: Uint8Array): boolean

      - #### Parameters

        - ##### value: number

        - ##### index: number

        - ##### obj: Uint8Array

        #### Returns boolean

  - ##### Optional thisArg: any

    If provided, it will be used as the this value for each invocation of predicate. If it is not provided, undefined is used instead.

  #### Returns number

### findIndex

- findIndex(predicate: (value: number, index: number, obj: Uint8Array) => boolean, thisArg?: any): number

- Inherited from Uint8Array.findIndex

  Returns the index of the first element in the array where predicate is true, and -1 otherwise.

  #### Parameters

  - ##### predicate: (value: number, index: number, obj: Uint8Array) => boolean

    find calls predicate once for each element of the array, in ascending order, until it finds one where predicate returns true. If such an element is found, findIndex immediately returns that element index. Otherwise, findIndex returns -1.

    - - (value: number, index: number, obj: Uint8Array): boolean

      - #### Parameters

        - ##### value: number

        - ##### index: number

        - ##### obj: Uint8Array

        #### Returns boolean

  - ##### Optional thisArg: any

    If provided, it will be used as the this value for each invocation of predicate. If it is not provided, undefined is used instead.

  #### Returns number

### forEach

- forEach(callbackfn: (value: number, index: number, array: Uint8Array) => void, thisArg?: any): void

- Inherited from Uint8Array.forEach

  Performs the specified action for each element in an array.

  #### Parameters

  - ##### callbackfn: (value: number, index: number, array: Uint8Array) => void

    A function that accepts up to three arguments. forEach calls the callbackfn function one time for each element in the array.

    - - (value: number, index: number, array: Uint8Array): void

      - #### Parameters

        - ##### value: number

        - ##### index: number

        - ##### array: Uint8Array

        #### Returns void

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns void

### includes

- includes(value: string | number | <internal>.Buffer, byteOffset?: number, encoding?: BufferEncoding): boolean

- Overrides Uint8Array.includes

  Equivalent to `buf.indexOf() !== -1`.

      import { Buffer } from 'buffer';

      const buf = Buffer.from('this is a buffer');

      console.log(buf.includes('this'));
      // Prints: true
      console.log(buf.includes('is'));
      // Prints: true
      console.log(buf.includes(Buffer.from('a buffer')));
      // Prints: true
      console.log(buf.includes(97));
      // Prints: true (97 is the decimal ASCII value for 'a')
      console.log(buf.includes(Buffer.from('a buffer example')));
      // Prints: false
      console.log(buf.includes(Buffer.from('a buffer example').slice(0, 8)));
      // Prints: true
      console.log(buf.includes('this', 4));
      // Prints: false

  since

    v5.3.0

  #### Parameters

  - ##### value: string | number | <internal>.Buffer

    What to search for.

  - ##### Optional byteOffset: number

  - ##### Optional encoding: BufferEncoding

  #### Returns boolean

  `true` if `value` was found in `buf`, `false` otherwise.

### indexOf

- indexOf(value: string | number | Uint8Array, byteOffset?: number, encoding?: BufferEncoding): number

- Overrides Uint8Array.indexOf

  If `value` is:

  - a string, `value` is interpreted according to the character encoding in`encoding`.
  - a `Buffer` or `Uint8Array`, `value` will be used in its entirety. To compare a partial `Buffer`, use `buf.slice()`.
  - a number, `value` will be interpreted as an unsigned 8-bit integer value between `0` and `255`.

      import { Buffer } from 'buffer';

      const buf = Buffer.from('this is a buffer');

      console.log(buf.indexOf('this'));
      // Prints: 0
      console.log(buf.indexOf('is'));
      // Prints: 2
      console.log(buf.indexOf(Buffer.from('a buffer')));
      // Prints: 8
      console.log(buf.indexOf(97));
      // Prints: 8 (97 is the decimal ASCII value for 'a')
      console.log(buf.indexOf(Buffer.from('a buffer example')));
      // Prints: -1
      console.log(buf.indexOf(Buffer.from('a buffer example').slice(0, 8)));
      // Prints: 8

      const utf16Buffer = Buffer.from('\u039a\u0391\u03a3\u03a3\u0395', 'utf16le');

      console.log(utf16Buffer.indexOf('\u03a3', 0, 'utf16le'));
      // Prints: 4
      console.log(utf16Buffer.indexOf('\u03a3', -4, 'utf16le'));
      // Prints: 6

  If `value` is not a string, number, or `Buffer`, this method will throw a`TypeError`. If `value` is a number, it will be coerced to a valid byte value, an integer between 0 and 255.

  If `byteOffset` is not a number, it will be coerced to a number. If the result of coercion is `NaN` or `0`, then the entire buffer will be searched. This behavior matches `String.prototype.indexOf()`.

      import { Buffer } from 'buffer';

      const b = Buffer.from('abcdef');

      // Passing a value that's a number, but not a valid byte.
      // Prints: 2, equivalent to searching for 99 or 'c'.
      console.log(b.indexOf(99.9));
      console.log(b.indexOf(256 + 99));

      // Passing a byteOffset that coerces to NaN or 0.
      // Prints: 1, searching the whole buffer.
      console.log(b.indexOf('b', undefined));
      console.log(b.indexOf('b', {}));
      console.log(b.indexOf('b', null));
      console.log(b.indexOf('b', []));

  If `value` is an empty string or empty `Buffer` and `byteOffset` is less than `buf.length`, `byteOffset` will be returned. If `value` is empty and`byteOffset` is at least `buf.length`, `buf.length` will be returned.

  since

    v1.5.0

  #### Parameters

  - ##### value: string | number | Uint8Array

    What to search for.

  - ##### Optional byteOffset: number

  - ##### Optional encoding: BufferEncoding

  #### Returns number

  The index of the first occurrence of `value` in `buf`, or `-1` if `buf` does not contain `value`.

### join

- join(separator?: string): string

- Inherited from Uint8Array.join

  Adds all the elements of an array separated by the specified separator string.

  #### Parameters

  - ##### Optional separator: string

    A string used to separate one element of an array from the next in the resulting String. If omitted, the array elements are separated with a comma.

  #### Returns string

### keys

- keys(): IterableIterator<number>

- Overrides Uint8Array.keys

  Creates and returns an iterator of `buf` keys (indices).

      import { Buffer } from 'buffer';

      const buf = Buffer.from('buffer');

      for (const key of buf.keys()) {
        console.log(key);
      }
      // Prints:
      //   0
      //   1
      //   2
      //   3
      //   4
      //   5

  since

    v1.1.0

  #### Returns IterableIterator<number>

### lastIndexOf

- lastIndexOf(value: string | number | Uint8Array, byteOffset?: number, encoding?: BufferEncoding): number

- Overrides Uint8Array.lastIndexOf

  Identical to `buf.indexOf()`, except the last occurrence of `value` is found rather than the first occurrence.

      import { Buffer } from 'buffer';

      const buf = Buffer.from('this buffer is a buffer');

      console.log(buf.lastIndexOf('this'));
      // Prints: 0
      console.log(buf.lastIndexOf('buffer'));
      // Prints: 17
      console.log(buf.lastIndexOf(Buffer.from('buffer')));
      // Prints: 17
      console.log(buf.lastIndexOf(97));
      // Prints: 15 (97 is the decimal ASCII value for 'a')
      console.log(buf.lastIndexOf(Buffer.from('yolo')));
      // Prints: -1
      console.log(buf.lastIndexOf('buffer', 5));
      // Prints: 5
      console.log(buf.lastIndexOf('buffer', 4));
      // Prints: -1

      const utf16Buffer = Buffer.from('\u039a\u0391\u03a3\u03a3\u0395', 'utf16le');

      console.log(utf16Buffer.lastIndexOf('\u03a3', undefined, 'utf16le'));
      // Prints: 6
      console.log(utf16Buffer.lastIndexOf('\u03a3', -5, 'utf16le'));
      // Prints: 4

  If `value` is not a string, number, or `Buffer`, this method will throw a`TypeError`. If `value` is a number, it will be coerced to a valid byte value, an integer between 0 and 255.

  If `byteOffset` is not a number, it will be coerced to a number. Any arguments that coerce to `NaN`, like `{}` or `undefined`, will search the whole buffer. This behavior matches `String.prototype.lastIndexOf()`.

      import { Buffer } from 'buffer';

      const b = Buffer.from('abcdef');

      // Passing a value that's a number, but not a valid byte.
      // Prints: 2, equivalent to searching for 99 or 'c'.
      console.log(b.lastIndexOf(99.9));
      console.log(b.lastIndexOf(256 + 99));

      // Passing a byteOffset that coerces to NaN.
      // Prints: 1, searching the whole buffer.
      console.log(b.lastIndexOf('b', undefined));
      console.log(b.lastIndexOf('b', {}));

      // Passing a byteOffset that coerces to 0.
      // Prints: -1, equivalent to passing 0.
      console.log(b.lastIndexOf('b', null));
      console.log(b.lastIndexOf('b', []));

  If `value` is an empty string or empty `Buffer`, `byteOffset` will be returned.

  since

    v6.0.0

  #### Parameters

  - ##### value: string | number | Uint8Array

    What to search for.

  - ##### Optional byteOffset: number

  - ##### Optional encoding: BufferEncoding

  #### Returns number

  The index of the last occurrence of `value` in `buf`, or `-1` if `buf` does not contain `value`.

### map

- map(callbackfn: (value: number, index: number, array: Uint8Array) => number, thisArg?: any): Uint8Array

- Inherited from Uint8Array.map

  Calls a defined callback function on each element of an array, and returns an array that contains the results.

  #### Parameters

  - ##### callbackfn: (value: number, index: number, array: Uint8Array) => number

    A function that accepts up to three arguments. The map method calls the callbackfn function one time for each element in the array.

    - - (value: number, index: number, array: Uint8Array): number

      - #### Parameters

        - ##### value: number

        - ##### index: number

        - ##### array: Uint8Array

        #### Returns number

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the callbackfn function. If thisArg is omitted, undefined is used as the this value.

  #### Returns Uint8Array

### readBigInt64BE

- readBigInt64BE(offset?: number): bigint

- Reads a signed, big-endian 64-bit integer from `buf` at the specified `offset`.

  Integers read from a `Buffer` are interpreted as two's complement signed values.

  since

    v12.0.0, v10.20.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns bigint

### readBigInt64LE

- readBigInt64LE(offset?: number): bigint

- Reads a signed, little-endian 64-bit integer from `buf` at the specified`offset`.

  Integers read from a `Buffer` are interpreted as two's complement signed values.

  since

    v12.0.0, v10.20.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns bigint

### readBigUInt64BE

- readBigUInt64BE(offset?: number): bigint

- Reads an unsigned, big-endian 64-bit integer from `buf` at the specified`offset`.

  This function is also available under the `readBigUint64BE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff]);

      console.log(buf.readBigUInt64BE(0));
      // Prints: 4294967295n

  since

    v12.0.0, v10.20.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns bigint

### readBigUInt64LE

- readBigUInt64LE(offset?: number): bigint

- Reads an unsigned, little-endian 64-bit integer from `buf` at the specified`offset`.

  This function is also available under the `readBigUint64LE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff]);

      console.log(buf.readBigUInt64LE(0));
      // Prints: 18446744069414584320n

  since

    v12.0.0, v10.20.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns bigint

### readBigUint64BE

- readBigUint64BE(offset?: number): bigint

- alias

    Buffer.readBigUInt64BE

  since

    v14.10.0, v12.19.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns bigint

### readBigUint64LE

- readBigUint64LE(offset?: number): bigint

- alias

    Buffer.readBigUInt64LE

  since

    v14.10.0, v12.19.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns bigint

### readDoubleBE

- readDoubleBE(offset?: number): number

- Reads a 64-bit, big-endian double from `buf` at the specified `offset`.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([1, 2, 3, 4, 5, 6, 7, 8]);

      console.log(buf.readDoubleBE(0));
      // Prints: 8.20788039913184e-304

  since

    v0.11.15

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readDoubleLE

- readDoubleLE(offset?: number): number

- Reads a 64-bit, little-endian double from `buf` at the specified `offset`.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([1, 2, 3, 4, 5, 6, 7, 8]);

      console.log(buf.readDoubleLE(0));
      // Prints: 5.447603722011605e-270
      console.log(buf.readDoubleLE(1));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.11.15

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readFloatBE

- readFloatBE(offset?: number): number

- Reads a 32-bit, big-endian float from `buf` at the specified `offset`.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([1, 2, 3, 4]);

      console.log(buf.readFloatBE(0));
      // Prints: 2.387939260590663e-38

  since

    v0.11.15

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readFloatLE

- readFloatLE(offset?: number): number

- Reads a 32-bit, little-endian float from `buf` at the specified `offset`.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([1, 2, 3, 4]);

      console.log(buf.readFloatLE(0));
      // Prints: 1.539989614439558e-36
      console.log(buf.readFloatLE(1));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.11.15

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readInt16BE

- readInt16BE(offset?: number): number

- Reads a signed, big-endian 16-bit integer from `buf` at the specified `offset`.

  Integers read from a `Buffer` are interpreted as two's complement signed values.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0, 5]);

      console.log(buf.readInt16BE(0));
      // Prints: 5

  since

    v0.5.5

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readInt16LE

- readInt16LE(offset?: number): number

- Reads a signed, little-endian 16-bit integer from `buf` at the specified`offset`.

  Integers read from a `Buffer` are interpreted as two's complement signed values.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0, 5]);

      console.log(buf.readInt16LE(0));
      // Prints: 1280
      console.log(buf.readInt16LE(1));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.5.5

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readInt32BE

- readInt32BE(offset?: number): number

- Reads a signed, big-endian 32-bit integer from `buf` at the specified `offset`.

  Integers read from a `Buffer` are interpreted as two's complement signed values.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0, 0, 0, 5]);

      console.log(buf.readInt32BE(0));
      // Prints: 5

  since

    v0.5.5

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readInt32LE

- readInt32LE(offset?: number): number

- Reads a signed, little-endian 32-bit integer from `buf` at the specified`offset`.

  Integers read from a `Buffer` are interpreted as two's complement signed values.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0, 0, 0, 5]);

      console.log(buf.readInt32LE(0));
      // Prints: 83886080
      console.log(buf.readInt32LE(1));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.5.5

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readInt8

- readInt8(offset?: number): number

- Reads a signed 8-bit integer from `buf` at the specified `offset`.

  Integers read from a `Buffer` are interpreted as two's complement signed values.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([-1, 5]);

      console.log(buf.readInt8(0));
      // Prints: -1
      console.log(buf.readInt8(1));
      // Prints: 5
      console.log(buf.readInt8(2));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.5.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readIntBE

- readIntBE(offset: number, byteLength: number): number

- Reads `byteLength` number of bytes from `buf` at the specified `offset`and interprets the result as a big-endian, two's complement signed value supporting up to 48 bits of accuracy.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x12, 0x34, 0x56, 0x78, 0x90, 0xab]);

      console.log(buf.readIntBE(0, 6).toString(16));
      // Prints: 1234567890ab
      console.log(buf.readIntBE(1, 6).toString(16));
      // Throws ERR_OUT_OF_RANGE.
      console.log(buf.readIntBE(1, 0).toString(16));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.11.15

  #### Parameters

  - ##### offset: number

    Number of bytes to skip before starting to read. Must satisfy `0 <= offset <= buf.length - byteLength`.

  - ##### byteLength: number

    Number of bytes to read. Must satisfy `0 < byteLength <= 6`.

  #### Returns number

### readIntLE

- readIntLE(offset: number, byteLength: number): number

- Reads `byteLength` number of bytes from `buf` at the specified `offset`and interprets the result as a little-endian, two's complement signed value supporting up to 48 bits of accuracy.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x12, 0x34, 0x56, 0x78, 0x90, 0xab]);

      console.log(buf.readIntLE(0, 6).toString(16));
      // Prints: -546f87a9cbee

  since

    v0.11.15

  #### Parameters

  - ##### offset: number

    Number of bytes to skip before starting to read. Must satisfy `0 <= offset <= buf.length - byteLength`.

  - ##### byteLength: number

    Number of bytes to read. Must satisfy `0 < byteLength <= 6`.

  #### Returns number

### readUInt16BE

- readUInt16BE(offset?: number): number

- Reads an unsigned, big-endian 16-bit integer from `buf` at the specified`offset`.

  This function is also available under the `readUint16BE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x12, 0x34, 0x56]);

      console.log(buf.readUInt16BE(0).toString(16));
      // Prints: 1234
      console.log(buf.readUInt16BE(1).toString(16));
      // Prints: 3456

  since

    v0.5.5

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUInt16LE

- readUInt16LE(offset?: number): number

- Reads an unsigned, little-endian 16-bit integer from `buf` at the specified`offset`.

  This function is also available under the `readUint16LE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x12, 0x34, 0x56]);

      console.log(buf.readUInt16LE(0).toString(16));
      // Prints: 3412
      console.log(buf.readUInt16LE(1).toString(16));
      // Prints: 5634
      console.log(buf.readUInt16LE(2).toString(16));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.5.5

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUInt32BE

- readUInt32BE(offset?: number): number

- Reads an unsigned, big-endian 32-bit integer from `buf` at the specified`offset`.

  This function is also available under the `readUint32BE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x12, 0x34, 0x56, 0x78]);

      console.log(buf.readUInt32BE(0).toString(16));
      // Prints: 12345678

  since

    v0.5.5

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUInt32LE

- readUInt32LE(offset?: number): number

- Reads an unsigned, little-endian 32-bit integer from `buf` at the specified`offset`.

  This function is also available under the `readUint32LE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x12, 0x34, 0x56, 0x78]);

      console.log(buf.readUInt32LE(0).toString(16));
      // Prints: 78563412
      console.log(buf.readUInt32LE(1).toString(16));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.5.5

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUInt8

- readUInt8(offset?: number): number

- Reads an unsigned 8-bit integer from `buf` at the specified `offset`.

  This function is also available under the `readUint8` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([1, -2]);

      console.log(buf.readUInt8(0));
      // Prints: 1
      console.log(buf.readUInt8(1));
      // Prints: 254
      console.log(buf.readUInt8(2));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.5.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUIntBE

- readUIntBE(offset: number, byteLength: number): number

- Reads `byteLength` number of bytes from `buf` at the specified `offset`and interprets the result as an unsigned big-endian integer supporting up to 48 bits of accuracy.

  This function is also available under the `readUintBE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x12, 0x34, 0x56, 0x78, 0x90, 0xab]);

      console.log(buf.readUIntBE(0, 6).toString(16));
      // Prints: 1234567890ab
      console.log(buf.readUIntBE(1, 6).toString(16));
      // Throws ERR_OUT_OF_RANGE.

  since

    v0.11.15

  #### Parameters

  - ##### offset: number

    Number of bytes to skip before starting to read. Must satisfy `0 <= offset <= buf.length - byteLength`.

  - ##### byteLength: number

    Number of bytes to read. Must satisfy `0 < byteLength <= 6`.

  #### Returns number

### readUIntLE

- readUIntLE(offset: number, byteLength: number): number

- Reads `byteLength` number of bytes from `buf` at the specified `offset`and interprets the result as an unsigned, little-endian integer supporting up to 48 bits of accuracy.

  This function is also available under the `readUintLE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x12, 0x34, 0x56, 0x78, 0x90, 0xab]);

      console.log(buf.readUIntLE(0, 6).toString(16));
      // Prints: ab9078563412

  since

    v0.11.15

  #### Parameters

  - ##### offset: number

    Number of bytes to skip before starting to read. Must satisfy `0 <= offset <= buf.length - byteLength`.

  - ##### byteLength: number

    Number of bytes to read. Must satisfy `0 < byteLength <= 6`.

  #### Returns number

### readUint16BE

- readUint16BE(offset?: number): number

- alias

    Buffer.readUInt16BE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUint16LE

- readUint16LE(offset?: number): number

- alias

    Buffer.readUInt16LE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUint32BE

- readUint32BE(offset?: number): number

- alias

    Buffer.readUInt32BE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUint32LE

- readUint32LE(offset?: number): number

- alias

    Buffer.readUInt32LE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUint8

- readUint8(offset?: number): number

- alias

    Buffer.readUInt8

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### Optional offset: number

  #### Returns number

### readUintBE

- readUintBE(offset: number, byteLength: number): number

- alias

    Buffer.readUIntBE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### offset: number

  - ##### byteLength: number

  #### Returns number

### readUintLE

- readUintLE(offset: number, byteLength: number): number

- alias

    Buffer.readUIntLE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### offset: number

  - ##### byteLength: number

  #### Returns number

### reduce

- reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number): number
- reduce(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number, initialValue: number): number
- reduce<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint8Array) => U, initialValue: U): U

- Inherited from Uint8Array.reduce

  Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Parameters

  - ##### callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number

    A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.

    - - (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array): number

      - #### Parameters

        - ##### previousValue: number

        - ##### currentValue: number

        - ##### currentIndex: number

        - ##### array: Uint8Array

        #### Returns number

- Inherited from Uint8Array.reduce

  #### Parameters

  - ##### callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number

    - - (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array): number

      - #### Parameters

        - ##### previousValue: number

        - ##### currentValue: number

        - ##### currentIndex: number

        - ##### array: Uint8Array

        #### Returns number

  - ##### initialValue: number

  #### Returns number

- Inherited from Uint8Array.reduce

  Calls the specified callback function for all the elements in an array. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint8Array) => U

    A function that accepts up to four arguments. The reduce method calls the callbackfn function one time for each element in the array.

    - - (previousValue: U, currentValue: number, currentIndex: number, array: Uint8Array): U

      - #### Parameters

        - ##### previousValue: U

        - ##### currentValue: number

        - ##### currentIndex: number

        - ##### array: Uint8Array

        #### Returns U

  - ##### initialValue: U

    If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.

  #### Returns U

### reduceRight

- reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number): number
- reduceRight(callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number, initialValue: number): number
- reduceRight<U>(callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint8Array) => U, initialValue: U): U

- Inherited from Uint8Array.reduceRight

  Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Parameters

  - ##### callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number

    A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.

    - - (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array): number

      - #### Parameters

        - ##### previousValue: number

        - ##### currentValue: number

        - ##### currentIndex: number

        - ##### array: Uint8Array

        #### Returns number

- Inherited from Uint8Array.reduceRight

  #### Parameters

  - ##### callbackfn: (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array) => number

    - - (previousValue: number, currentValue: number, currentIndex: number, array: Uint8Array): number

      - #### Parameters

        - ##### previousValue: number

        - ##### currentValue: number

        - ##### currentIndex: number

        - ##### array: Uint8Array

        #### Returns number

  - ##### initialValue: number

  #### Returns number

- Inherited from Uint8Array.reduceRight

  Calls the specified callback function for all the elements in an array, in descending order. The return value of the callback function is the accumulated result, and is provided as an argument in the next call to the callback function.

  #### Type parameters

  - #### U

  #### Parameters

  - ##### callbackfn: (previousValue: U, currentValue: number, currentIndex: number, array: Uint8Array) => U

    A function that accepts up to four arguments. The reduceRight method calls the callbackfn function one time for each element in the array.

    - - (previousValue: U, currentValue: number, currentIndex: number, array: Uint8Array): U

      - #### Parameters

        - ##### previousValue: U

        - ##### currentValue: number

        - ##### currentIndex: number

        - ##### array: Uint8Array

        #### Returns U

  - ##### initialValue: U

    If initialValue is specified, it is used as the initial value to start the accumulation. The first call to the callbackfn function provides this value as an argument instead of an array value.

  #### Returns U

### reverse

- reverse(): <internal>.Buffer

- Overrides Uint8Array.reverse

  #### Returns <internal>.Buffer

### set

- set(array: ArrayLike<number>, offset?: number): void

- Inherited from Uint8Array.set

  Sets a value or an array of values.

  #### Parameters

  - ##### array: ArrayLike<number>

    A typed or untyped array of values to set.

  - ##### Optional offset: number

    The index in the current array at which the values are to be written.

  #### Returns void

### slice

- slice(start?: number, end?: number): <internal>.Buffer

- Overrides Uint8Array.slice

  Returns a new `Buffer` that references the same memory as the original, but offset and cropped by the `start` and `end` indices.

  This is the same behavior as `buf.subarray()`.

  This method is not compatible with the `Uint8Array.prototype.slice()`, which is a superclass of `Buffer`. To copy the slice, use`Uint8Array.prototype.slice()`.

      import { Buffer } from 'buffer';

      const buf = Buffer.from('buffer');

      const copiedBuf = Uint8Array.prototype.slice.call(buf);
      copiedBuf[0]++;
      console.log(copiedBuf.toString());
      // Prints: cuffer

      console.log(buf.toString());
      // Prints: buffer

  since

    v0.3.0

  #### Parameters

  - ##### Optional start: number

  - ##### Optional end: number

  #### Returns <internal>.Buffer

### some

- some(predicate: (value: number, index: number, array: Uint8Array) => unknown, thisArg?: any): boolean

- Inherited from Uint8Array.some

  Determines whether the specified callback function returns true for any element of an array.

  #### Parameters

  - ##### predicate: (value: number, index: number, array: Uint8Array) => unknown

    A function that accepts up to three arguments. The some method calls the predicate function for each element in the array until the predicate returns a value which is coercible to the Boolean value true, or until the end of the array.

    - - (value: number, index: number, array: Uint8Array): unknown

      - #### Parameters

        - ##### value: number

        - ##### index: number

        - ##### array: Uint8Array

        #### Returns unknown

  - ##### Optional thisArg: any

    An object to which the this keyword can refer in the predicate function. If thisArg is omitted, undefined is used as the this value.

  #### Returns boolean

### sort

- sort(compareFn?: (a: number, b: number) => number): <internal>.Buffer

- Inherited from Uint8Array.sort

  Sorts an array.

  #### Parameters

  - ##### Optional compareFn: (a: number, b: number) => number

    Function used to determine the order of the elements. It is expected to return a negative value if first argument is less than second argument, zero if they're equal and a positive value otherwise. If omitted, the elements are sorted in ascending order.

        [11,2,22,1].sort((a, b) => a - b)

    - - (a: number, b: number): number

      - #### Parameters

        - ##### a: number

        - ##### b: number

        #### Returns number

  #### Returns <internal>.Buffer

### subarray

- subarray(start?: number, end?: number): <internal>.Buffer

- Overrides Uint8Array.subarray

  Returns a new `Buffer` that references the same memory as the original, but offset and cropped by the `start` and `end` indices.

  Specifying `end` greater than `buf.length` will return the same result as that of `end` equal to `buf.length`.

  This method is inherited from `TypedArray.prototype.subarray()`.

  Modifying the new `Buffer` slice will modify the memory in the original `Buffer`because the allocated memory of the two objects overlap.

      import { Buffer } from 'buffer';

      // Create a `Buffer` with the ASCII alphabet, take a slice, and modify one byte
      // from the original `Buffer`.

      const buf1 = Buffer.allocUnsafe(26);

      for (let i = 0; i < 26; i++) {
        // 97 is the decimal ASCII value for 'a'.
        buf1[i] = i + 97;
      }

      const buf2 = buf1.subarray(0, 3);

      console.log(buf2.toString('ascii', 0, buf2.length));
      // Prints: abc

      buf1[0] = 33;

      console.log(buf2.toString('ascii', 0, buf2.length));
      // Prints: !bc

  Specifying negative indexes causes the slice to be generated relative to the end of `buf` rather than the beginning.

      import { Buffer } from 'buffer';

      const buf = Buffer.from('buffer');

      console.log(buf.subarray(-6, -1).toString());
      // Prints: buffe
      // (Equivalent to buf.subarray(0, 5).)

      console.log(buf.subarray(-6, -2).toString());
      // Prints: buff
      // (Equivalent to buf.subarray(0, 4).)

      console.log(buf.subarray(-5, -2).toString());
      // Prints: uff
      // (Equivalent to buf.subarray(1, 4).)

  since

    v3.0.0

  #### Parameters

  - ##### Optional start: number

  - ##### Optional end: number

  #### Returns <internal>.Buffer

### swap16

- swap16(): <internal>.Buffer

- Interprets `buf` as an array of unsigned 16-bit integers and swaps the byte order in-place. Throws `ERR_INVALID_BUFFER_SIZE` if `buf.length` is not a multiple of 2.

      import { Buffer } from 'buffer';

      const buf1 = Buffer.from([0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8]);

      console.log(buf1);
      // Prints: <Buffer 01 02 03 04 05 06 07 08>

      buf1.swap16();

      console.log(buf1);
      // Prints: <Buffer 02 01 04 03 06 05 08 07>

      const buf2 = Buffer.from([0x1, 0x2, 0x3]);

      buf2.swap16();
      // Throws ERR_INVALID_BUFFER_SIZE.

  One convenient use of `buf.swap16()` is to perform a fast in-place conversion between UTF-16 little-endian and UTF-16 big-endian:

      import { Buffer } from 'buffer';

      const buf = Buffer.from('This is little-endian UTF-16', 'utf16le');
      buf.swap16(); // Convert to big-endian UTF-16 text.

  since

    v5.10.0

  #### Returns <internal>.Buffer

  A reference to `buf`.

### swap32

- swap32(): <internal>.Buffer

- Interprets `buf` as an array of unsigned 32-bit integers and swaps the byte order in-place. Throws `ERR_INVALID_BUFFER_SIZE` if `buf.length` is not a multiple of 4.

      import { Buffer } from 'buffer';

      const buf1 = Buffer.from([0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8]);

      console.log(buf1);
      // Prints: <Buffer 01 02 03 04 05 06 07 08>

      buf1.swap32();

      console.log(buf1);
      // Prints: <Buffer 04 03 02 01 08 07 06 05>

      const buf2 = Buffer.from([0x1, 0x2, 0x3]);

      buf2.swap32();
      // Throws ERR_INVALID_BUFFER_SIZE.

  since

    v5.10.0

  #### Returns <internal>.Buffer

  A reference to `buf`.

### swap64

- swap64(): <internal>.Buffer

- Interprets `buf` as an array of 64-bit numbers and swaps byte order in-place. Throws `ERR_INVALID_BUFFER_SIZE` if `buf.length` is not a multiple of 8.

      import { Buffer } from 'buffer';

      const buf1 = Buffer.from([0x1, 0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8]);

      console.log(buf1);
      // Prints: <Buffer 01 02 03 04 05 06 07 08>

      buf1.swap64();

      console.log(buf1);
      // Prints: <Buffer 08 07 06 05 04 03 02 01>

      const buf2 = Buffer.from([0x1, 0x2, 0x3]);

      buf2.swap64();
      // Throws ERR_INVALID_BUFFER_SIZE.

  since

    v6.3.0

  #### Returns <internal>.Buffer

  A reference to `buf`.

### toJSON

- toJSON(): { data: number[]; type: "Buffer" }

- Returns a JSON representation of `buf`. `JSON.stringify()` implicitly calls this function when stringifying a `Buffer` instance.

  `Buffer.from()` accepts objects in the format returned from this method. In particular, `Buffer.from(buf.toJSON())` works like `Buffer.from(buf)`.

      import { Buffer } from 'buffer';

      const buf = Buffer.from([0x1, 0x2, 0x3, 0x4, 0x5]);
      const json = JSON.stringify(buf);

      console.log(json);
      // Prints: {"type":"Buffer","data":[1,2,3,4,5]}

      const copy = JSON.parse(json, (key, value) => {
        return value &#x26;&#x26; value.type === 'Buffer' ?
          Buffer.from(value) :
          value;
      });

      console.log(copy);
      // Prints: <Buffer 01 02 03 04 05>

  since

    v0.9.2

  #### Returns { data: number[]; type: "Buffer" }

  - ##### data: number[]

  - ##### type: "Buffer"

### toLocaleString

- toLocaleString(): string

- Inherited from Uint8Array.toLocaleString

  Converts a number to a string by using the current locale.

  #### Returns string

### toString

- toString(encoding?: BufferEncoding, start?: number, end?: number): string

- Overrides Uint8Array.toString

  Decodes `buf` to a string according to the specified character encoding in`encoding`. `start` and `end` may be passed to decode only a subset of `buf`.

  If `encoding` is `'utf8'` and a byte sequence in the input is not valid UTF-8, then each invalid byte is replaced with the replacement character `U+FFFD`.

  The maximum length of a string instance (in UTF-16 code units) is available as {@link constants.MAX_STRING_LENGTH}.

      import { Buffer } from 'buffer';

      const buf1 = Buffer.allocUnsafe(26);

      for (let i = 0; i < 26; i++) {
        // 97 is the decimal ASCII value for 'a'.
        buf1[i] = i + 97;
      }

      console.log(buf1.toString('utf8'));
      // Prints: abcdefghijklmnopqrstuvwxyz
      console.log(buf1.toString('utf8', 0, 5));
      // Prints: abcde

      const buf2 = Buffer.from('tést');

      console.log(buf2.toString('hex'));
      // Prints: 74c3a97374
      console.log(buf2.toString('utf8', 0, 3));
      // Prints: té
      console.log(buf2.toString(undefined, 0, 3));
      // Prints: té

  since

    v0.1.90

  #### Parameters

  - ##### Optional encoding: BufferEncoding

  - ##### Optional start: number

  - ##### Optional end: number

  #### Returns string

### valueOf

- valueOf(): Uint8Array

- Inherited from Uint8Array.valueOf

  Returns the primitive value of the specified object.

  #### Returns Uint8Array

### values

- values(): IterableIterator<number>

- Overrides Uint8Array.values

  Creates and returns an iterator for `buf` values (bytes). This function is called automatically when a `Buffer` is used in a `for..of` statement.

      import { Buffer } from 'buffer';

      const buf = Buffer.from('buffer');

      for (const value of buf.values()) {
        console.log(value);
      }
      // Prints:
      //   98
      //   117
      //   102
      //   102
      //   101
      //   114

      for (const value of buf) {
        console.log(value);
      }
      // Prints:
      //   98
      //   117
      //   102
      //   102
      //   101
      //   114

  since

    v1.1.0

  #### Returns IterableIterator<number>

### write

- write(string: string, encoding?: BufferEncoding): number
- write(string: string, offset: number, encoding?: BufferEncoding): number
- write(string: string, offset: number, length: number, encoding?: BufferEncoding): number

- Writes `string` to `buf` at `offset` according to the character encoding in`encoding`. The `length` parameter is the number of bytes to write. If `buf` did not contain enough space to fit the entire string, only part of `string` will be written. However, partially encoded characters will not be written.

      import { Buffer } from 'buffer';

      const buf = Buffer.alloc(256);

      const len = buf.write('\u00bd + \u00bc = \u00be', 0);

      console.log(`${len} bytes: ${buf.toString('utf8', 0, len)}`);
      // Prints: 12 bytes: ½ + ¼ = ¾

      const buffer = Buffer.alloc(10);

      const length = buffer.write('abcd', 8);

      console.log(`${length} bytes: ${buffer.toString('utf8', 8, 10)}`);
      // Prints: 2 bytes : ab

  since

    v0.1.90

  #### Parameters

  - ##### string: string

    String to write to `buf`.

  - ##### Optional encoding: BufferEncoding

  #### Returns number

  Number of bytes written.

- #### Parameters

  - ##### string: string

  - ##### offset: number

  - ##### Optional encoding: BufferEncoding

  #### Returns number

- #### Parameters

  - ##### string: string

  - ##### offset: number

  - ##### length: number

  - ##### Optional encoding: BufferEncoding

  #### Returns number

### writeBigInt64BE

- writeBigInt64BE(value: bigint, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as big-endian.

  `value` is interpreted and written as a two's complement signed integer.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(8);

      buf.writeBigInt64BE(0x0102030405060708n, 0);

      console.log(buf);
      // Prints: <Buffer 01 02 03 04 05 06 07 08>

  since

    v12.0.0, v10.20.0

  #### Parameters

  - ##### value: bigint

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeBigInt64LE

- writeBigInt64LE(value: bigint, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as little-endian.

  `value` is interpreted and written as a two's complement signed integer.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(8);

      buf.writeBigInt64LE(0x0102030405060708n, 0);

      console.log(buf);
      // Prints: <Buffer 08 07 06 05 04 03 02 01>

  since

    v12.0.0, v10.20.0

  #### Parameters

  - ##### value: bigint

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeBigUInt64BE

- writeBigUInt64BE(value: bigint, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as big-endian.

  This function is also available under the `writeBigUint64BE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(8);

      buf.writeBigUInt64BE(0xdecafafecacefaden, 0);

      console.log(buf);
      // Prints: <Buffer de ca fa fe ca ce fa de>

  since

    v12.0.0, v10.20.0

  #### Parameters

  - ##### value: bigint

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeBigUInt64LE

- writeBigUInt64LE(value: bigint, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as little-endian

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(8);

      buf.writeBigUInt64LE(0xdecafafecacefaden, 0);

      console.log(buf);
      // Prints: <Buffer de fa ce ca fe fa ca de>

  This function is also available under the `writeBigUint64LE` alias.

  since

    v12.0.0, v10.20.0

  #### Parameters

  - ##### value: bigint

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeBigUint64BE

- writeBigUint64BE(value: bigint, offset?: number): number

- alias

    Buffer.writeBigUInt64BE

  since

    v14.10.0, v12.19.0

  #### Parameters

  - ##### value: bigint

  - ##### Optional offset: number

  #### Returns number

### writeBigUint64LE

- writeBigUint64LE(value: bigint, offset?: number): number

- alias

    Buffer.writeBigUInt64LE

  since

    v14.10.0, v12.19.0

  #### Parameters

  - ##### value: bigint

  - ##### Optional offset: number

  #### Returns number

### writeDoubleBE

- writeDoubleBE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as big-endian. The `value`must be a JavaScript number. Behavior is undefined when `value` is anything other than a JavaScript number.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(8);

      buf.writeDoubleBE(123.456, 0);

      console.log(buf);
      // Prints: <Buffer 40 5e dd 2f 1a 9f be 77>

  since

    v0.11.15

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeDoubleLE

- writeDoubleLE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as little-endian. The `value`must be a JavaScript number. Behavior is undefined when `value` is anything other than a JavaScript number.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(8);

      buf.writeDoubleLE(123.456, 0);

      console.log(buf);
      // Prints: <Buffer 77 be 9f 1a 2f dd 5e 40>

  since

    v0.11.15

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeFloatBE

- writeFloatBE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as big-endian. Behavior is undefined when `value` is anything other than a JavaScript number.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(4);

      buf.writeFloatBE(0xcafebabe, 0);

      console.log(buf);
      // Prints: <Buffer 4f 4a fe bb>

  since

    v0.11.15

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeFloatLE

- writeFloatLE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as little-endian. Behavior is undefined when `value` is anything other than a JavaScript number.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(4);

      buf.writeFloatLE(0xcafebabe, 0);

      console.log(buf);
      // Prints: <Buffer bb fe 4a 4f>

  since

    v0.11.15

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeInt16BE

- writeInt16BE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as big-endian. The `value`must be a valid signed 16-bit integer. Behavior is undefined when `value` is anything other than a signed 16-bit integer.

  The `value` is interpreted and written as a two's complement signed integer.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(2);

      buf.writeInt16BE(0x0102, 0);

      console.log(buf);
      // Prints: <Buffer 01 02>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeInt16LE

- writeInt16LE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as little-endian. The `value`must be a valid signed 16-bit integer. Behavior is undefined when `value` is anything other than a signed 16-bit integer.

  The `value` is interpreted and written as a two's complement signed integer.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(2);

      buf.writeInt16LE(0x0304, 0);

      console.log(buf);
      // Prints: <Buffer 04 03>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeInt32BE

- writeInt32BE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as big-endian. The `value`must be a valid signed 32-bit integer. Behavior is undefined when `value` is anything other than a signed 32-bit integer.

  The `value` is interpreted and written as a two's complement signed integer.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(4);

      buf.writeInt32BE(0x01020304, 0);

      console.log(buf);
      // Prints: <Buffer 01 02 03 04>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeInt32LE

- writeInt32LE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as little-endian. The `value`must be a valid signed 32-bit integer. Behavior is undefined when `value` is anything other than a signed 32-bit integer.

  The `value` is interpreted and written as a two's complement signed integer.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(4);

      buf.writeInt32LE(0x05060708, 0);

      console.log(buf);
      // Prints: <Buffer 08 07 06 05>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeInt8

- writeInt8(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset`. `value` must be a valid signed 8-bit integer. Behavior is undefined when `value` is anything other than a signed 8-bit integer.

  `value` is interpreted and written as a two's complement signed integer.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(2);

      buf.writeInt8(2, 0);
      buf.writeInt8(-2, 1);

      console.log(buf);
      // Prints: <Buffer 02 fe>

  since

    v0.5.0

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeIntBE

- writeIntBE(value: number, offset: number, byteLength: number): number

- Writes `byteLength` bytes of `value` to `buf` at the specified `offset`as big-endian. Supports up to 48 bits of accuracy. Behavior is undefined when`value` is anything other than a signed integer.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(6);

      buf.writeIntBE(0x1234567890ab, 0, 6);

      console.log(buf);
      // Prints: <Buffer 12 34 56 78 90 ab>

  since

    v0.11.15

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### offset: number

    Number of bytes to skip before starting to write. Must satisfy `0 <= offset <= buf.length - byteLength`.

  - ##### byteLength: number

    Number of bytes to write. Must satisfy `0 < byteLength <= 6`.

  #### Returns number

  `offset` plus the number of bytes written.

### writeIntLE

- writeIntLE(value: number, offset: number, byteLength: number): number

- Writes `byteLength` bytes of `value` to `buf` at the specified `offset`as little-endian. Supports up to 48 bits of accuracy. Behavior is undefined when `value` is anything other than a signed integer.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(6);

      buf.writeIntLE(0x1234567890ab, 0, 6);

      console.log(buf);
      // Prints: <Buffer ab 90 78 56 34 12>

  since

    v0.11.15

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### offset: number

    Number of bytes to skip before starting to write. Must satisfy `0 <= offset <= buf.length - byteLength`.

  - ##### byteLength: number

    Number of bytes to write. Must satisfy `0 < byteLength <= 6`.

  #### Returns number

  `offset` plus the number of bytes written.

### writeUInt16BE

- writeUInt16BE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as big-endian. The `value`must be a valid unsigned 16-bit integer. Behavior is undefined when `value`is anything other than an unsigned 16-bit integer.

  This function is also available under the `writeUint16BE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(4);

      buf.writeUInt16BE(0xdead, 0);
      buf.writeUInt16BE(0xbeef, 2);

      console.log(buf);
      // Prints: <Buffer de ad be ef>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeUInt16LE

- writeUInt16LE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as little-endian. The `value`must be a valid unsigned 16-bit integer. Behavior is undefined when `value` is anything other than an unsigned 16-bit integer.

  This function is also available under the `writeUint16LE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(4);

      buf.writeUInt16LE(0xdead, 0);
      buf.writeUInt16LE(0xbeef, 2);

      console.log(buf);
      // Prints: <Buffer ad de ef be>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeUInt32BE

- writeUInt32BE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as big-endian. The `value`must be a valid unsigned 32-bit integer. Behavior is undefined when `value`is anything other than an unsigned 32-bit integer.

  This function is also available under the `writeUint32BE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(4);

      buf.writeUInt32BE(0xfeedface, 0);

      console.log(buf);
      // Prints: <Buffer fe ed fa ce>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeUInt32LE

- writeUInt32LE(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset` as little-endian. The `value`must be a valid unsigned 32-bit integer. Behavior is undefined when `value` is anything other than an unsigned 32-bit integer.

  This function is also available under the `writeUint32LE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(4);

      buf.writeUInt32LE(0xfeedface, 0);

      console.log(buf);
      // Prints: <Buffer ce fa ed fe>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeUInt8

- writeUInt8(value: number, offset?: number): number

- Writes `value` to `buf` at the specified `offset`. `value` must be a valid unsigned 8-bit integer. Behavior is undefined when `value` is anything other than an unsigned 8-bit integer.

  This function is also available under the `writeUint8` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(4);

      buf.writeUInt8(0x3, 0);
      buf.writeUInt8(0x4, 1);
      buf.writeUInt8(0x23, 2);
      buf.writeUInt8(0x42, 3);

      console.log(buf);
      // Prints: <Buffer 03 04 23 42>

  since

    v0.5.0

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### Optional offset: number

  #### Returns number

  `offset` plus the number of bytes written.

### writeUIntBE

- writeUIntBE(value: number, offset: number, byteLength: number): number

- Writes `byteLength` bytes of `value` to `buf` at the specified `offset`as big-endian. Supports up to 48 bits of accuracy. Behavior is undefined when `value` is anything other than an unsigned integer.

  This function is also available under the `writeUintBE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(6);

      buf.writeUIntBE(0x1234567890ab, 0, 6);

      console.log(buf);
      // Prints: <Buffer 12 34 56 78 90 ab>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### offset: number

    Number of bytes to skip before starting to write. Must satisfy `0 <= offset <= buf.length - byteLength`.

  - ##### byteLength: number

    Number of bytes to write. Must satisfy `0 < byteLength <= 6`.

  #### Returns number

  `offset` plus the number of bytes written.

### writeUIntLE

- writeUIntLE(value: number, offset: number, byteLength: number): number

- Writes `byteLength` bytes of `value` to `buf` at the specified `offset`as little-endian. Supports up to 48 bits of accuracy. Behavior is undefined when `value` is anything other than an unsigned integer.

  This function is also available under the `writeUintLE` alias.

      import { Buffer } from 'buffer';

      const buf = Buffer.allocUnsafe(6);

      buf.writeUIntLE(0x1234567890ab, 0, 6);

      console.log(buf);
      // Prints: <Buffer ab 90 78 56 34 12>

  since

    v0.5.5

  #### Parameters

  - ##### value: number

    Number to be written to `buf`.

  - ##### offset: number

    Number of bytes to skip before starting to write. Must satisfy `0 <= offset <= buf.length - byteLength`.

  - ##### byteLength: number

    Number of bytes to write. Must satisfy `0 < byteLength <= 6`.

  #### Returns number

  `offset` plus the number of bytes written.

### writeUint16BE

- writeUint16BE(value: number, offset?: number): number

- alias

    Buffer.writeUInt16BE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### value: number

  - ##### Optional offset: number

  #### Returns number

### writeUint16LE

- writeUint16LE(value: number, offset?: number): number

- alias

    Buffer.writeUInt16LE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### value: number

  - ##### Optional offset: number

  #### Returns number

### writeUint32BE

- writeUint32BE(value: number, offset?: number): number

- alias

    Buffer.writeUInt32BE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### value: number

  - ##### Optional offset: number

  #### Returns number

### writeUint32LE

- writeUint32LE(value: number, offset?: number): number

- alias

    Buffer.writeUInt32LE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### value: number

  - ##### Optional offset: number

  #### Returns number

### writeUint8

- writeUint8(value: number, offset?: number): number

- alias

    Buffer.writeUInt8

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### value: number

  - ##### Optional offset: number

  #### Returns number

### writeUintBE

- writeUintBE(value: number, offset: number, byteLength: number): number

- alias

    Buffer.writeUIntBE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### value: number

  - ##### offset: number

  - ##### byteLength: number

  #### Returns number

### writeUintLE

- writeUintLE(value: number, offset: number, byteLength: number): number

- alias

    Buffer.writeUIntLE

  since

    v14.9.0, v12.19.0

  #### Parameters

  - ##### value: number

  - ##### offset: number

  - ##### byteLength: number

  #### Returns number

Generated using TypeDoc